diff -ruN vdr-1.7.24/osdbase.c vdr-1.7.25/osdbase.c
--- vdr-1.7.24/osdbase.c	2010-12-12 14:41:28.000000000 +0100
+++ vdr-1.7.25/osdbase.c	2012-03-02 16:49:57.000000000 +0100
@@ -4,13 +4,14 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: osdbase.c 2.3 2010/12/12 13:41:28 kls Exp $
+ * $Id: osdbase.c 2.4 2012/03/02 15:49:57 kls Exp $
  */
 
 #include "osdbase.h"
 #include <string.h>
 #include "device.h"
 #include "i18n.h"
+#include "menuitems.h"
 #include "remote.h"
 #include "status.h"
 
@@ -85,6 +86,7 @@
   current = marked = -1;
   subMenu = NULL;
   helpRed = helpGreen = helpYellow = helpBlue = NULL;
+  helpDisplayed = false;
   status = NULL;
   if (!displayMenuCount++)
      SetDisplayMenu();
@@ -154,6 +156,15 @@
   title = strdup(Title);
 }
 
+void cOsdMenu::DisplayHelp(bool Force)
+{
+  if (!helpDisplayed || Force) {
+     displayMenu->SetButtons(helpRed, helpGreen, helpYellow, helpBlue);
+     cStatus::MsgOsdHelpKeys(helpRed, helpGreen, helpYellow, helpBlue);
+     helpDisplayed = true;
+     }
+}
+
 void cOsdMenu::SetHelp(const char *Red, const char *Green, const char *Yellow, const char *Blue)
 {
   // strings are NOT copied - must be constants!!!
@@ -161,8 +172,7 @@
   helpGreen  = Green;
   helpYellow = Yellow;
   helpBlue   = Blue;
-  displayMenu->SetButtons(helpRed, helpGreen, helpYellow, helpBlue);
-  cStatus::MsgOsdHelpKeys(helpRed, helpGreen, helpYellow, helpBlue);
+  DisplayHelp(true);
 }
 
 void cOsdMenu::Del(int Index)
@@ -205,8 +215,7 @@
   displayMenu->SetTabs(cols[0], cols[1], cols[2], cols[3], cols[4]);//XXX
   displayMenu->SetTitle(title);
   cStatus::MsgOsdTitle(title);
-  displayMenu->SetButtons(helpRed, helpGreen, helpYellow, helpBlue);
-  cStatus::MsgOsdHelpKeys(helpRed, helpGreen, helpYellow, helpBlue);
+  DisplayHelp(true);
   int count = Count();
   if (count > 0) {
      int ni = 0;
@@ -263,6 +272,12 @@
         cStatus::MsgOsdCurrentItem(item->Text());
      if (!Current)
         item->SetFresh(true); // leaving the current item resets 'fresh'
+     if (cMenuEditItem *MenuEditItem = dynamic_cast<cMenuEditItem *>(item)) {
+        if (!MenuEditItem->DisplayHelp())
+           DisplayHelp();
+        else
+           helpDisplayed = false;
+        }
      }
 }
 
diff -ruN vdr-1.7.24/osdbase.h vdr-1.7.25/osdbase.h
--- vdr-1.7.24/osdbase.h	2010-01-16 15:25:31.000000000 +0100
+++ vdr-1.7.25/osdbase.h	2012-03-02 16:49:57.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: osdbase.h 2.1 2010/01/16 14:25:31 kls Exp $
+ * $Id: osdbase.h 2.2 2012/03/02 15:49:57 kls Exp $
  */
 
 #ifndef __OSDBASE_H
@@ -92,9 +92,11 @@
   int first, current, marked;
   cOsdMenu *subMenu;
   const char *helpRed, *helpGreen, *helpYellow, *helpBlue;
+  bool helpDisplayed;
   char *status;
   int digit;
   bool hasHotkeys;
+  void DisplayHelp(bool Force = false);
 protected:
   void SetDisplayMenu(void);
   cSkinDisplayMenu *DisplayMenu(void) { return displayMenu; }
diff -ruN vdr-1.7.24/pat.c vdr-1.7.25/pat.c
--- vdr-1.7.24/pat.c	2011-04-17 15:45:25.000000000 +0200
+++ vdr-1.7.25/pat.c	2012-03-02 11:56:45.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: pat.c 2.16 2011/04/17 13:45:25 kls Exp $
+ * $Id: pat.c 2.17 2012/03/02 10:56:45 kls Exp $
  */
 
 #include "pat.h"
@@ -360,7 +360,7 @@
                       break;
               case 3: // STREAMTYPE_11172_AUDIO
               case 4: // STREAMTYPE_13818_AUDIO
-              case 0x0F: // ISO/IEC 13818-7 Audio with ADTS transport sytax
+              case 0x0F: // ISO/IEC 13818-7 Audio with ADTS transport syntax
               case 0x11: // ISO/IEC 14496-3 Audio with LATM transport syntax
                       {
                       if (NumApids < MAXAPIDS) {
diff -ruN vdr-1.7.24/receiver.c vdr-1.7.25/receiver.c
--- vdr-1.7.24/receiver.c	2010-12-13 00:16:25.000000000 +0100
+++ vdr-1.7.25/receiver.c	2012-02-29 12:49:36.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: receiver.c 2.4 2010/12/12 23:16:25 kls Exp $
+ * $Id: receiver.c 2.5 2012/02/29 11:49:36 kls Exp $
  */
 
 #include "receiver.h"
@@ -16,7 +16,7 @@
 {
   device = NULL;
   channelID = ChannelID;
-  priority = Priority;
+  priority = constrain(Priority, MINPRIORITY, MAXPRIORITY);
   numPids = 0;
   AddPid(Pid);
   AddPids(Pids1);
@@ -28,7 +28,7 @@
 cReceiver::cReceiver(const cChannel *Channel, int Priority)
 {
   device = NULL;
-  priority = Priority;
+  priority = constrain(Priority, MINPRIORITY, MAXPRIORITY);
   numPids = 0;
   SetPids(Channel);
 }
diff -ruN vdr-1.7.24/receiver.h vdr-1.7.25/receiver.h
--- vdr-1.7.24/receiver.h	2011-12-04 14:38:17.000000000 +0100
+++ vdr-1.7.25/receiver.h	2012-03-01 10:50:24.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: receiver.h 2.2 2011/12/04 13:38:17 kls Exp $
+ * $Id: receiver.h 2.5 2012/03/01 09:50:24 kls Exp $
  */
 
 #ifndef __RECEIVER_H
@@ -43,15 +43,15 @@
 #ifdef LEGACY_CRECEIVER
   cReceiver(tChannelID ChannelID, int Priority, int Pid, const int *Pids1 = NULL, const int *Pids2 = NULL, const int *Pids3 = NULL);
 #endif
-  cReceiver(const cChannel *Channel = NULL, int Priority = -1);
+  cReceiver(const cChannel *Channel = NULL, int Priority = MINPRIORITY);
                ///< Creates a new receiver for the given Channel with the given Priority.
-               ///< If Channel is not NULL, its pids set by a call to SetPids().
+               ///< If Channel is not NULL, its pids are set by a call to SetPids().
                ///< Otherwise pids can be added to the receiver by separate calls to the AddPid[s]
                ///< functions.
                ///< The total number of PIDs added to a receiver must not exceed MAXRECEIVEPIDS.
-               ///< Priority may be any value in the range -99..99. Negative values indicate
-               ///< that this cReceiver may be detached at any time (without blocking the
-               ///< cDevice it is attached to).
+               ///< Priority may be any value in the range MINPRIORITY...MAXPRIORITY. Negative values indicate
+               ///< that this cReceiver may be detached at any time in favor of a timer recording
+               ///< or live viewing (without blocking the cDevice it is attached to).
   virtual ~cReceiver();
   bool AddPid(int Pid);
                ///< Adds the given Pid to the list of PIDs of this receiver.
diff -ruN vdr-1.7.24/recording.c vdr-1.7.25/recording.c
--- vdr-1.7.24/recording.c	2012-02-19 11:44:45.000000000 +0100
+++ vdr-1.7.25/recording.c	2012-02-26 14:58:26.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recording.c 2.50 2012/02/19 10:44:45 kls Exp $
+ * $Id: recording.c 2.51 2012/02/26 13:58:26 kls Exp $
  */
 
 #include "recording.h"
@@ -1571,7 +1571,7 @@
      if (!Record && PauseLive) {
         // Wait until the index file contains at least two frames:
         time_t tmax = time(NULL) + MAXWAITFORINDEXFILE;
-        while (time(NULL) < tmax && FileSize(fileName) < 2 * sizeof(tIndexTs))
+        while (time(NULL) < tmax && FileSize(fileName) < off_t(2 * sizeof(tIndexTs)))
               cCondWait::SleepMs(INDEXFILETESTINTERVAL);
         }
      int delta = 0;
diff -ruN vdr-1.7.24/remux.c vdr-1.7.25/remux.c
--- vdr-1.7.24/remux.c	2012-01-12 13:07:58.000000000 +0100
+++ vdr-1.7.25/remux.c	2012-03-02 11:56:49.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: remux.c 2.63 2012/01/12 12:07:58 kls Exp $
+ * $Id: remux.c 2.64 2012/03/02 10:56:49 kls Exp $
  */
 
 #include "remux.h"
@@ -514,7 +514,7 @@
                       break;
            case 0x03: // STREAMTYPE_11172_AUDIO
            case 0x04: // STREAMTYPE_13818_AUDIO
-           case 0x0F: // ISO/IEC 13818-7 Audio with ADTS transport sytax
+           case 0x0F: // ISO/IEC 13818-7 Audio with ADTS transport syntax
            case 0x11: // ISO/IEC 14496-3 Audio with LATM transport syntax
                       {
                       if (NumApids < MAXAPIDS) {
diff -ruN vdr-1.7.24/skins.c vdr-1.7.25/skins.c
--- vdr-1.7.24/skins.c	2011-08-21 13:21:19.000000000 +0200
+++ vdr-1.7.25/skins.c	2012-02-20 12:47:15.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: skins.c 2.3 2011/08/21 11:21:19 kls Exp $
+ * $Id: skins.c 2.4 2012/02/20 11:47:15 kls Exp $
  */
 
 #include "skins.h"
@@ -78,7 +78,7 @@
   tabs[3] = Tab3 ? tabs[2] + Tab3 : 0;
   tabs[4] = Tab4 ? tabs[3] + Tab4 : 0;
   tabs[5] = Tab5 ? tabs[4] + Tab5 : 0;
-  int AvgCharWidth = Setup.FontOsdSize * 3 / 5; // just an estimate
+  int AvgCharWidth = Setup.FontOsdSize * 4 / 6; // just an estimate
   for (int i = 1; i < MaxTabs; i++)
       tabs[i] *= AvgCharWidth;
 }
diff -ruN vdr-1.7.24/timers.c vdr-1.7.25/timers.c
--- vdr-1.7.24/timers.c	2011-08-06 15:13:54.000000000 +0200
+++ vdr-1.7.25/timers.c	2012-02-27 10:38:41.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: timers.c 2.5 2011/08/06 13:13:54 kls Exp $
+ * $Id: timers.c 2.8 2012/02/27 09:38:41 kls Exp $
  */
 
 #include "timers.h"
@@ -384,13 +384,14 @@
   return mktime(&tm);
 }
 
-char *cTimer::SetFile(const char *File)
+void cTimer::SetFile(const char *File)
 {
   if (!isempty(File))
      Utf8Strn0Cpy(file, File, sizeof(file));
-  return file;
 }
 
+#define EITPRESENTFOLLOWINGRATE 10 // max. seconds between two occurrences of the "EIT present/following table for the actual multiplex" (2s by the standard, using some more for safety)
+
 bool cTimer::Matches(time_t t, bool Directly, int Margin) const
 {
   startTime = stopTime = 0;
@@ -434,8 +435,12 @@
         if (Margin || !Directly) {
            startTime = event->StartTime();
            stopTime = event->EndTime();
-           if (!Margin)
-              return event->IsRunning(true);
+           if (!Margin) { // this is an actual check
+              if (event->Schedule()->PresentSeenWithin(EITPRESENTFOLLOWINGRATE)) // VPS control can only work with up-to-date events...
+                 return event->IsRunning(true);
+              else
+                 return startTime <= t && t < stopTime; // ...otherwise we fall back to normal timer handling
+              }
            }
         }
      return startTime <= t + Margin && t < stopTime; // must stop *before* stopTime to allow adjacent timers
@@ -591,11 +596,42 @@
   inVpsMargin = InVpsMargin;
 }
 
+void cTimer::SetDay(time_t Day)
+{
+  day = Day;
+}
+
+void cTimer::SetWeekDays(int WeekDays)
+{
+  weekdays = WeekDays;
+}
+
+void cTimer::SetStart(int Start)
+{
+  start = Start;
+}
+
+void cTimer::SetStop(int Stop)
+{
+  stop = Stop;
+}
+
 void cTimer::SetPriority(int Priority)
 {
   priority = Priority;
 }
 
+void cTimer::SetLifetime(int Lifetime)
+{
+  lifetime = Lifetime;
+}
+
+void cTimer::SetAux(const char *Aux)
+{
+  free(aux);
+  aux = strdup(Aux);
+}
+
 void cTimer::SetDeferred(int Seconds)
 {
   deferred = time(NULL) + Seconds;
diff -ruN vdr-1.7.24/timers.h vdr-1.7.25/timers.h
--- vdr-1.7.24/timers.h	2011-08-06 14:59:32.000000000 +0200
+++ vdr-1.7.25/timers.h	2012-02-20 16:52:57.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: timers.h 2.1 2011/08/06 12:59:32 kls Exp $
+ * $Id: timers.h 2.3 2012/02/20 15:52:57 kls Exp $
  */
 
 #ifndef __TIMERS_H
@@ -75,7 +75,7 @@
   bool DayMatches(time_t t) const;
   static time_t IncDay(time_t t, int Days);
   static time_t SetTime(time_t t, int SecondsFromMidnight);
-  char *SetFile(const char *File);
+  void SetFile(const char *File);
   bool Matches(time_t t = 0, bool Directly = false, int Margin = 0) const;
   int Matches(const cEvent *Event, int *Overlap = NULL) const;
   bool Expired(void) const;
@@ -86,7 +86,13 @@
   void SetRecording(bool Recording);
   void SetPending(bool Pending);
   void SetInVpsMargin(bool InVpsMargin);
+  void SetDay(time_t Day);
+  void SetWeekDays(int WeekDays);
+  void SetStart(int Start);
+  void SetStop(int Stop);
   void SetPriority(int Priority);
+  void SetLifetime(int Lifetime);
+  void SetAux(const char *Aux);
   void SetDeferred(int Seconds);
   void SetFlags(uint Flags);
   void ClrFlags(uint Flags);
diff -ruN vdr-1.7.24/tools.h vdr-1.7.25/tools.h
--- vdr-1.7.24/tools.h	2012-02-18 16:29:50.000000000 +0100
+++ vdr-1.7.25/tools.h	2012-02-29 11:41:00.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: tools.h 2.15 2012/02/18 15:29:50 kls Exp $
+ * $Id: tools.h 2.16 2012/02/29 10:41:00 kls Exp $
  */
 
 #ifndef __TOOLS_H
@@ -57,6 +57,8 @@
 template<class T> inline void swap(T &a, T &b) { T t = a; a = b; b = t; }
 #endif
 
+template<class T> inline T constrain(T v, T l, T h) { return v < l ? l : v > h ? h : v; }
+
 void syslog_with_tid(int priority, const char *format, ...) __attribute__ ((format (printf, 2, 3)));
 
 #define BCDCHARTOINT(x) (10 * ((x & 0xF0) >> 4) + (x & 0xF))
diff -ruN vdr-1.7.24/transfer.c vdr-1.7.25/transfer.c
--- vdr-1.7.24/transfer.c	2010-01-30 12:10:25.000000000 +0100
+++ vdr-1.7.25/transfer.c	2012-02-29 15:16:23.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: transfer.c 2.5 2010/01/30 11:10:25 kls Exp $
+ * $Id: transfer.c 2.6 2012/02/29 14:16:23 kls Exp $
  */
 
 #include "transfer.h"
@@ -12,7 +12,7 @@
 // --- cTransfer -------------------------------------------------------------
 
 cTransfer::cTransfer(const cChannel *Channel)
-:cReceiver(Channel)
+:cReceiver(Channel, TRANSFERPRIORITY)
 {
   patPmtGenerator.SetChannel(Channel);
 }
diff -ruN vdr-1.7.24/vdr.c vdr-1.7.25/vdr.c
--- vdr-1.7.24/vdr.c	2012-02-19 12:37:35.000000000 +0100
+++ vdr-1.7.25/vdr.c	2012-02-27 11:59:55.000000000 +0100
@@ -22,7 +22,7 @@
  *
  * The project's page is at http://www.tvdr.de
  *
- * $Id: vdr.c 2.29 2012/02/19 11:37:35 kls Exp $
+ * $Id: vdr.c 2.30 2012/02/27 10:59:55 kls Exp $
  */
 
 #include <getopt.h>
@@ -53,7 +53,6 @@
 #include "menu.h"
 #include "osdbase.h"
 #include "plugin.h"
-#include "rcu.h"
 #include "recording.h"
 #include "shutdown.h"
 #include "skinclassic.h"
@@ -201,14 +200,11 @@
 
   bool UseKbd = true;
   const char *LircDevice = NULL;
-  const char *RcuDevice = NULL;
 #if !defined(REMOTE_KBD)
   UseKbd = false;
 #endif
 #if defined(REMOTE_LIRC)
   LircDevice = LIRC_DEVICE;
-#elif defined(REMOTE_RCU)
-  RcuDevice = RCU_DEVICE;
 #endif
 #if defined(VDR_USER)
   VdrUser = VDR_USER;
@@ -236,7 +232,6 @@
       { "no-kbd",   no_argument,       NULL, 'n' | 0x100 },
       { "plugin",   required_argument, NULL, 'P' },
       { "port",     required_argument, NULL, 'p' },
-      { "rcu",      optional_argument, NULL, 'r' | 0x100 },
       { "record",   required_argument, NULL, 'r' },
       { "shutdown", required_argument, NULL, 's' },
       { "split",    no_argument,       NULL, 's' | 0x100 },
@@ -350,9 +345,6 @@
                     break;
           case 'P': PluginManager.AddPlugin(optarg);
                     break;
-          case 'r' | 0x100:
-                    RcuDevice = optarg ? : RCU_DEVICE;
-                    break;
           case 'r': cRecordingUserCommand::SetCommand(optarg);
                     break;
           case 's': ShutdownHandler.SetShutdownCommand(optarg);
@@ -455,8 +447,6 @@
                "  -p PORT,  --port=PORT    use PORT for SVDRP (default: %d)\n"
                "                           0 turns off SVDRP\n"
                "  -P OPT,   --plugin=OPT   load a plugin defined by the given options\n"
-               "            --rcu[=PATH]   use a remote control device, attached to PATH\n"
-               "                           (default: %s)\n"
                "  -r CMD,   --record=CMD   call CMD before and after a recording\n"
                "  -s CMD,   --shutdown=CMD call CMD to shutdown the computer\n"
                "            --split        split edited files at the editing marks (only\n"
@@ -479,7 +469,6 @@
                LIRC_DEVICE,
                LOCDIR,
                DEFAULTSVDRPPORT,
-               RCU_DEVICE,
                VideoDirectory,
                DEFAULTWATCHDOG
                );
@@ -707,8 +696,6 @@
      }
 
   // Remote Controls:
-  if (RcuDevice)
-     new cRcuRemote(RcuDevice);
   if (LircDevice)
      new cLircRemote(LircDevice);
   if (!DaemonMode && HasStdin && UseKbd)
